unit AVarc;
interface
 uses Dos, objects, ArcView;
 Type
       TArcFHeader = Record
                 HeadId  : byte;
                 DataType : byte;   { 0 = no more data }
                 Name     : array[0..12] of char;
                 CompSize : longint;
                 FileDate : word;
                 FileTime : word;
                 Crc      : word;
                 OrigSize : longint;
               end;


     ParcArchive=^TarcArchive;
     TarcArchive=object(TArchive)
                  Constructor Init(AFile:PStream);
                  Function FindNext(var Sr:TArcRec):boolean;virtual;
                  private
                   Header:TArcFHeader;
                   Procedure GetHeader;
                 end;
implementation
 Constructor TarcArchive.Init;
 begin
  Inherited Init(AFile);
  GetHeader;
 end;
 Function TarcArchive.FindNext(var Sr:TArcRec):boolean;
 var I:Integer;
 begin
  if Header.DataType=0 then
   FindNext:=False
  else
  With Header do
   begin
     FindNext:=True;
     i:=0;
     Sr.Name:='';
     While Name[i]<>#0 do
      begin
       Sr.Name:=Sr.Name+Name[i];
       inc(i);
      end;
     TDosDate(Sr.Time).Date:=FileDate;
     TDosDate(Sr.Time).Time:=FileTime;
     Sr.Size:=OrigSize;
     Sr.PackedSize:=CompSize;
     Sr.Attr:=0;
  end;
 end;
Procedure TArcArchive.GetHeader;
begin
 F^.Read(Header,SizeOf(TArcFHeader));
 F^.Seek(F^.GetPos+Header.CompSize);
end;
end.
